#ifndef MNLClient_h
#define MNLClient_h

#define MAX_PKT_LEN 1420

#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/types.h>

#define MNL_SOCK_FILE "MNLDaemon.sock"

#ifdef __cplusplus
extern "C" {
#endif 

typedef struct {
  
  /** The length of the packet to be sent out */
  int mPktLen;
 
  /** Where should this packet be sent.  All internal fields in network byte order.
    */
  struct sockaddr_in mToAddr;

  /** The length of mToAddrLen */
  socklen_t mToLen;

  /** The flags associated with the sendto call */
  int mFlags;

  /** The byte sequence number of the first data byte in the packet contained in mpPktContents */
  int mSeqNumStart;

  /** The number of bytes of actual data contained in mpPktContents */
  int mDataLen;

  /** The current size of your window (if using sliding window) in bytes. */
  int mWindowSize;
  
  
  /** The contents of the packet to be sent out */
  unsigned char mpPktContents[0];

} SendMsg;

int MNLClientInit();
ssize_t MNL_sendto(int s, const void* buf, size_t len, int flags, const struct sockaddr *to, socklen_t tolen, 
                    int iSeqNumStart, int iDataLen, int iWindowSize, int *irError);

#ifdef __cplusplus
}
#endif 

#endif //MNLClient_h
