#ifndef SendQueue_h
#define SendQueue_h

#include <sys/time.h>
#include <sys/types.h>
#include <queue>
using namespace std;

#include "MNLClient.h"
#include "PacketBufComparator.h"

class PacketBuf;
class PacketDropper;

class SendQueue {

public:

  SendQueue(uint32_t iRTTMean, uint32_t iRTTVar, PacketDropper* ipPktDropper);

  void AddPacket(SendMsg* ipSendMsg);
  
  bool Init();
  void TransmitAll();
  bool IsEmpty();

  struct timeval GetTimeToNextSend();

private:
 
  int mTxSkt;

  PacketDropper* mpPktDropper;

  void Transmit(PacketBuf* ipPkt);

  uint32_t mRTTMean;
  uint32_t mRTTVar;

  priority_queue<PacketBuf, vector<PacketBuf*>, PacketBufComparator> mPktQueue;
};

#endif //SendQueue_h
